+++
date = "2016-09-05"
weight = 100

title = "Dbgsym"

aliases = [
    "/old-wiki/Dbgsym"
]
+++

# Dbgsym packages

Packages automatically generate debug symbol packages at build time, the
packages add the package name extension (<package_name>**-dbgsym**).

## Infrastructure

To be able to benefit from *dbgsym* packages, infrastructure must be
ready for them, the requirements are:

  - *reprepro*: must support *dbgsym* since 4.17.0
  - *debhelper*: with *dbgsym* support since 9.20160114
  - *dpkg-dev*: support for *dbgsym* since 1.18.2\~

When building packages with those tools, automatic debug symbols will be
generated for all built packages.

## Since when can it be used in Apertis

*dbgsym* packages are supported since 16.06 release, however, not all
packages were rebuilt, therefore there are missing packages without
*dbgsym* packages. During 16.09 a full rebuild has been done with the
main archives to ensure all packages have a corresponding dbgsym
package.

## How to use dbgsym packages

Usually, a package name with **-dbgsym** extension, from Apertis
repositories, needs to be installed in the target runtime system, then
your system is able to resolve debug symbols for debugging purposes.

As reference you might read Debian documentation on [how to get a
backtrace](https://wiki.debian.org/HowToGetABacktrace), but please make
sure to use Apertis repositories to fetch *dbgsym* packages.

## dbg packages are deprecated

Before *dbgsym* packages, package maintainers had to manually create
their -dbg packages listed in the *debian/control* file, these packages
were mirrored in every mirror and every suite, wasting lots of storage
space. This is not relevant for Apertis, but it is very relevant for
Debian (Apertis parent distribution).

Therefore with *dbgsym* packages, there is no need to add any new
stanzas to *debian/control*.

If you want to transition from a former **-dbg** package to a
**-dbgsym** package you might want to look into the
[dh_strip](http://manpages.ubuntu.com/manpages/xenial/en/man1/dh_strip.1.html)'s
switch --dbgsym-migration=pkgname-dbg (\<\< currentversion\~)' switch
and drop **-dbg** from *debian/control* file.